const {paths} = require('./');
// load environment variables from .env files
// before overrides scripts are read
require(paths.scriptVersion + '/config/env');
const overrideConfig = require(paths.configOverrides);

const webpack = typeof overrideConfig === 'function'
  ? overrideConfig
  : overrideConfig.webpack || ((config, env) => config);

if (overrideConfig.devserver) {
  console.log(
    'Warning: `devserver` has been deprecated. Please use `devServer` instead as ' +
    '`devserver` will not be used in the next major release.'
  )
}

const devServer = overrideConfig.devServer || overrideConfig.devserver
  || ((configFunction) =>
    (proxy, allowedHost) =>
      configFunction(proxy, allowedHost));

const { custom = {}, override} = overrideConfig

const jest = overrideConfig.jest || ((config) => config);

const pathsOverride = overrideConfig.paths || ((paths, env) => paths);

// normalized overrides functions
module.exports = {
  override,
  custom,
  webpack,
  devServer,
  jest,
  paths: pathsOverride
};
