module.exports = (moduleConfig) => {
  const findOneOf = (cb) => {
    return moduleConfig.rules.find((rule) => cb(rule)).oneOf;
  };
  let loaders = findOneOf((rule) => Array.isArray(rule.oneOf));
  const lessLoader = loaders.find(
    (item) =>
      item.test &&
      typeof item.test.test === 'function' &&
      item.test.test('.less')
  );
  if (lessLoader) {
    findOneOf((rule) => {
      if (Array.isArray(rule.oneOf)) {
        const newOneOf = [];
        rule.oneOf.forEach((item) => {
          if (
            item.test &&
            typeof item.test.test === 'function' &&
            (item.test.test('.sass') || item.test.test('.module.sass'))
          ) {
            return;
          }
          newOneOf.push(item);
        });
        rule.oneOf = newOneOf;
      }
      return Array.isArray(rule.oneOf);
    });
  }
  return moduleConfig;
};
